#include <stdio.h>
#include <stdlib.h>
#include <cuda.h>

#define POCET 256

__global__ static void scitaj(const int *v1,const int *v2,int *vv)
{
  vv[threadIdx.x] = v1[threadIdx.x] + v2[threadIdx.x];
}

int main(void)
{
  int *h_v1,*h_v2,*h_vv;
  int *d_v1,*d_v2,*d_vv;

  h_v1=(int *)malloc(sizeof(int)*POCET);
  h_v2=(int *)malloc(sizeof(int)*POCET);
  h_vv=(int *)malloc(sizeof(int)*POCET);
  for(int i=0;i<POCET;i++){
    h_v1[i]=rand()&0xF;
    h_v2[i]=rand()&0xF;
  }

  cudaMalloc(&d_v1,POCET*sizeof(int));
  cudaMalloc(&d_v2,POCET*sizeof(int));
  cudaMalloc(&d_vv,POCET*sizeof(int));

  cudaMemcpy(d_v1,h_v1,sizeof(int)*POCET,cudaMemcpyHostToDevice);
  cudaMemcpy(d_v2,h_v2,sizeof(int)*POCET,cudaMemcpyHostToDevice);

  scitaj<<<1,POCET>>>(d_v1,d_v2,d_vv);

  cudaMemcpy(h_vv,d_vv,sizeof(int)*POCET,cudaMemcpyDeviceToHost);

  cudaFree(d_v1);
  cudaFree(d_v2);
  cudaFree(d_vv);

  for(int i=0;i<POCET;i++){
    printf("%2d + %2d = %2d\n",h_v1[i],h_v2[i],h_vv[i]);
  }

  free(h_v1);
  free(h_v2);
  free(h_vv);

  return 0;
}