#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <cuda.h>

__device__ static void porovnaj(const int Npol,int *pole)
{
  if(threadIdx.x<Npol){
    int v1=pole[threadIdx.x];
    int v2=pole[threadIdx.x+Npol];
    if(v2<v1){
      pole[threadIdx.x]=v2;
    }
  }
}

__global__ static void porovnajNkrat(const int N,int *pole)
{
  int x;
  for(x=N/2;x>=1;x/=2){
    porovnaj(x,pole);
    __syncthreads();
  }
}

#define POCET 512

int main(void)
{
  int *h_pole,*d_pole,m;
  h_pole=(int *)malloc(sizeof(int)*POCET);
  srand(time(0));
  for(int i=0;i<POCET;i++){
    h_pole[i]=rand();
    if(i){
      m=h_pole[i]<m?h_pole[i]:m;
    }
    else{
      m=h_pole[i];
    }
  }
  printf("CPU: %d\n",m);
  cudaMalloc(&d_pole,sizeof(int)*POCET);
  cudaMemcpy(d_pole,h_pole,sizeof(int)*POCET,cudaMemcpyHostToDevice);

  porovnajNkrat<<<1,POCET/2>>>(POCET,d_pole);

  cudaMemcpy(h_pole,d_pole,sizeof(int)*POCET,cudaMemcpyDeviceToHost);
  cudaFree(d_pole);
  printf("CUDA: %d\n",h_pole[0]);
}